;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.0 #9615 (MINGW64)
;--------------------------------------------------------
	.module StateMapaFeo
	.optsdcc -mgbz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _SpriteManagerAdd
	.globl _SpriteManagerLoad
	.globl _InitScrollColor
	.globl _ZInitScrollTilesColor
	.globl _PlayMusic
	.globl _bank_STATE_MAPAFEO
	.globl _Start_STATE_MAPAFEO
	.globl _Update_STATE_MAPAFEO
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_bank_STATE_MAPAFEO::
	.ds 1
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;StateMapaFeo.c:3: UINT8 bank_STATE_MAPAFEO = 2;
	ld	hl,#_bank_STATE_MAPAFEO
	ld	(hl),#0x02
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE_2
;StateMapaFeo.c:16: void Start_STATE_MAPAFEO() {
;	---------------------------------
; Function Start_STATE_MAPAFEO
; ---------------------------------
_Start_STATE_MAPAFEO::
	add	sp, #-9
;StateMapaFeo.c:19: UINT8 collision_tiles[] = {1, 2, 3, 4, 5, 6, 0};
	ldhl	sp,#0
	ld	a,l
	ld	d,h
	ldhl	sp,#7
	ld	(hl+),a
	ld	(hl),d
	dec	hl
	ld	a,(hl+)
	ld	h,(hl)
	ld	l,a
	ld	(hl),#0x01
	ldhl	sp,#(8 - 1)
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	bc
	ld	a,#0x02
	ld	(bc),a
	dec	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	bc
	inc	bc
	ld	a,#0x03
	ld	(bc),a
	dec	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	bc
	inc	bc
	inc	bc
	ld	a,#0x04
	ld	(bc),a
	dec	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	hl,#0x0004
	add	hl,de
	ld	c,l
	ld	b,h
	ld	a,#0x05
	ld	(bc),a
	ldhl	sp,#(8 - 1)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	hl,#0x0005
	add	hl,de
	ld	c,l
	ld	b,h
	ld	a,#0x06
	ld	(bc),a
	ldhl	sp,#(8 - 1)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	hl,#0x0006
	add	hl,de
	ld	c,l
	ld	b,h
	xor	a, a
	ld	(bc),a
;StateMapaFeo.c:21: SPRITES_8x16;
	ld	de,#0xff40
	ld	a,(de)
	ld	c,a
	ld	b,#0x00
	ld	a,c
	set	2, a
	ld	c,a
	ld	hl,#0xff40
	ld	(hl),c
;StateMapaFeo.c:22: for(i = 0; i != n_sprite_types; ++ i) {
	ld	b,#0x00
00103$:
	ld	hl,#_n_sprite_types
	ld	a,(hl)
	sub	a, b
	jr	Z,00101$
;StateMapaFeo.c:23: SpriteManagerLoad(i);
	push	bc
	push	bc
	inc	sp
	call	_SpriteManagerLoad
	inc	sp
	pop	bc
;StateMapaFeo.c:22: for(i = 0; i != n_sprite_types; ++ i) {
	inc	b
	jr	00103$
00101$:
;StateMapaFeo.c:25: SHOW_SPRITES;
	ld	de,#0xff40
	ld	a,(de)
	ld	c,a
	ld	b,#0x00
	ld	a,c
	set	1, a
	ld	c,a
	ld	hl,#0xff40
	ld	(hl),c
;StateMapaFeo.c:27: scroll_target = SpriteManagerAdd(SPRITE_PLAYER, 50, 50);
	ld	hl,#0x0032
	push	hl
	ld	l, #0x32
	push	hl
	xor	a, a
	push	af
	inc	sp
	call	_SpriteManagerAdd
	add	sp, #5
	ld	hl,#_scroll_target
	ld	(hl),e
	inc	hl
	ld	(hl),d
;StateMapaFeo.c:28: SpriteManagerAdd(SPRITE_MONOFEO, 10, 10);
	ld	hl,#0x000a
	push	hl
	ld	l, #0x0a
	push	hl
	ld	a,#0x01
	push	af
	inc	sp
	call	_SpriteManagerAdd
	add	sp, #5
;StateMapaFeo.c:30: InitScrollTiles(0, 8, MapaFeoTiles, 3);
	ld	hl,#0x0000
	push	hl
	ld	a,#0x03
	push	af
	inc	sp
	ld	hl,#_MapaFeoTiles
	push	hl
	ld	hl,#0x0800
	push	hl
	call	_ZInitScrollTilesColor
	add	sp, #7
;StateMapaFeo.c:31: InitScroll(MapaFeoWidth, MapaFeoHeight, MapaFeo, collision_tiles, 0, 3);
	ldhl	sp,#(8 - 1)
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,#0x0000
	push	hl
	ld	a,#0x03
	push	af
	inc	sp
	ld	l, #0x00
	push	hl
	push	bc
	ld	hl,#_MapaFeo
	push	hl
	ld	hl,#0x001e
	push	hl
	ld	l, #0x1e
	push	hl
	call	_InitScrollColor
	add	sp, #13
;StateMapaFeo.c:32: SHOW_BKG;
	ld	de,#0xff40
	ld	a,(de)
	ld	c,a
	ld	b,#0x00
	ld	a,c
	set	0, a
	ld	c,a
	ld	hl,#0xff40
	ld	(hl),c
;StateMapaFeo.c:34: NR52_REG = 0x80;
	ld	l, #0x26
	ld	(hl),#0x80
;StateMapaFeo.c:35: NR51_REG = 0XFF;
	ld	l, #0x25
	ld	(hl),#0xff
;StateMapaFeo.c:36: NR50_REG = 0X77;
	ld	l, #0x24
	ld	(hl),#0x77
;StateMapaFeo.c:38: PlayMusic(musiquita_mod_Data, 3, 1);
	ld	hl,#0x0103
	push	hl
	ld	hl,#_musiquita_mod_Data
	push	hl
	call	_PlayMusic
	add	sp, #4
	add	sp, #9
	ret
;StateMapaFeo.c:41: void Update_STATE_MAPAFEO() {
;	---------------------------------
; Function Update_STATE_MAPAFEO
; ---------------------------------
_Update_STATE_MAPAFEO::
;StateMapaFeo.c:42: }
	ret
	.area _CODE_2
	.area _CABS (ABS)
