;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.0 #9615 (MINGW64)
;--------------------------------------------------------
	.module StateLevel
	.optsdcc -mgbz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _SpriteManagerAdd
	.globl _SpriteManagerLoad
	.globl _InitScrollColor
	.globl _ZInitScrollTilesColor
	.globl _PlayMusic
	.globl _bank_STATE_LEVEL
	.globl _Start_STATE_LEVEL
	.globl _Update_STATE_LEVEL
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_bank_STATE_LEVEL::
	.ds 1
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;StateLevel.c:3: UINT8 bank_STATE_LEVEL = 2;
	ld	hl,#_bank_STATE_LEVEL
	ld	(hl),#0x02
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE_2
;StateLevel.c:18: void Start_STATE_LEVEL() {
;	---------------------------------
; Function Start_STATE_LEVEL
; ---------------------------------
_Start_STATE_LEVEL::
	add	sp, #-6
;StateLevel.c:20: UINT8 collision_tiles[] = {1, 3, 4, 0};
	ldhl	sp,#0
	ld	a,l
	ld	d,h
	ldhl	sp,#4
	ld	(hl+),a
	ld	(hl),d
	dec	hl
	ld	a,(hl+)
	ld	h,(hl)
	ld	l,a
	ld	(hl),#0x01
	ldhl	sp,#(5 - 1)
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	bc
	ld	a,#0x03
	ld	(bc),a
	dec	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	bc
	inc	bc
	ld	a,#0x04
	ld	(bc),a
	dec	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	bc
	inc	bc
	inc	bc
	xor	a, a
	ld	(bc),a
;StateLevel.c:24: SPRITES_8x16;
	ld	de,#0xff40
	ld	a,(de)
	ld	c,a
	ld	b,#0x00
	ld	a,c
	set	2, a
	ld	c,a
	ld	hl,#0xff40
	ld	(hl),c
;StateLevel.c:25: for(i = 0; i != n_sprite_types; ++ i) {
	ld	b,#0x00
00103$:
	ld	hl,#_n_sprite_types
	ld	a,(hl)
	sub	a, b
	jr	Z,00101$
;StateLevel.c:26: SpriteManagerLoad(i);
	push	bc
	push	bc
	inc	sp
	call	_SpriteManagerLoad
	inc	sp
	pop	bc
;StateLevel.c:25: for(i = 0; i != n_sprite_types; ++ i) {
	inc	b
	jr	00103$
00101$:
;StateLevel.c:28: SHOW_SPRITES;
	ld	de,#0xff40
	ld	a,(de)
	ld	c,a
	ld	b,#0x00
	ld	a,c
	set	1, a
	ld	c,a
	ld	hl,#0xff40
	ld	(hl),c
;StateLevel.c:33: SpriteManagerAdd(SPRITE_MONOFEO, 10, 10);
	ld	hl,#0x000a
	push	hl
	ld	l, #0x0a
	push	hl
	ld	a,#0x01
	push	af
	inc	sp
	call	_SpriteManagerAdd
	add	sp, #5
;StateLevel.c:34: scroll_target =SpriteManagerAdd(SPRITE_PLAYER, 50, 50);
	ld	hl,#0x0032
	push	hl
	ld	l, #0x32
	push	hl
	xor	a, a
	push	af
	inc	sp
	call	_SpriteManagerAdd
	add	sp, #5
	ld	hl,#_scroll_target
	ld	(hl),e
	inc	hl
	ld	(hl),d
;StateLevel.c:39: InitScrollTiles(0, 5, LevelTiles, 3);
	ld	hl,#0x0000
	push	hl
	ld	a,#0x03
	push	af
	inc	sp
	ld	hl,#_LevelTiles
	push	hl
	ld	hl,#0x0500
	push	hl
	call	_ZInitScrollTilesColor
	add	sp, #7
;StateLevel.c:42: InitScroll(LevelMapWidth, LevelMapHeight, LevelMap, collision_tiles, 0, 3);
	ldhl	sp,#(5 - 1)
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,#0x0000
	push	hl
	ld	a,#0x03
	push	af
	inc	sp
	ld	l, #0x00
	push	hl
	push	bc
	ld	hl,#_LevelMap
	push	hl
	ld	hl,#0x001e
	push	hl
	ld	l, #0x1e
	push	hl
	call	_InitScrollColor
	add	sp, #13
;StateLevel.c:43: SHOW_BKG;
	ld	de,#0xff40
	ld	a,(de)
	ld	c,a
	ld	b,#0x00
	ld	a,c
	set	0, a
	ld	c,a
	ld	hl,#0xff40
	ld	(hl),c
;StateLevel.c:46: NR52_REG = 0x80;	//activar sonido ...
	ld	l, #0x26
	ld	(hl),#0x80
;StateLevel.c:47: NR51_REG = 0xFF;	// ...con todos los canales...
	ld	l, #0x25
	ld	(hl),#0xff
;StateLevel.c:48: NR50_REG = 0x77;	// ... CON TODO EL POWER! 
	ld	l, #0x24
	ld	(hl),#0x77
;StateLevel.c:51: PlayMusic(musiquita_mod_Data, 3, 1);
	ld	hl,#0x0103
	push	hl
	ld	hl,#_musiquita_mod_Data
	push	hl
	call	_PlayMusic
	add	sp, #4
	add	sp, #6
	ret
;StateLevel.c:55: void Update_STATE_LEVEL() {
;	---------------------------------
; Function Update_STATE_LEVEL
; ---------------------------------
_Update_STATE_LEVEL::
;StateLevel.c:57: }
	ret
	.area _CODE_2
	.area _CABS (ABS)
