#pragma bank=2
#include "SpriteMonitos.h"
UINT8 bank_SPRITE_MONITOS = 2;

#include <gb/gb.h>
#include <rand.h>

#include "Scroll.h"
#include "SpriteManager.h"

#include "ZGBMain.h"

const UINT8 animacion_chico[] = {2, 0, 1};
const UINT8 animacion_chica[] = {2, 4, 5};

struct WaitTime {
    INT8 data;
};

void Start_SPRITE_MONITOS() {
	
	UINT8 genero;
	struct WaitTime* waitTime;
	genero = rand();
	
	
	
	waitTime = THIS->custom_data;
    waitTime->data = 1;
	
	//SetSpriteAnim(THIS, animacion_chico, 15u);
	//SetSpriteAnim(THIS, animacion_chica, 15u);
	
	if (genero%2 == 0) {
		SetSpriteAnim(THIS, animacion_chica, 15u);
	} else {
		SetSpriteAnim(THIS, animacion_chico, 15u);
	}
}

void Update_SPRITE_MONITOS() {
	
	struct WaitTime* waitTime = THIS->custom_data;
	
	//moverse hasta llegar a 40
	if (THIS->x != 55) {
		TranslateSprite(THIS, -1, 0);
	} else {
		//esperar
		if (waitTime->data < 100) {
			waitTime->data++;
		} else {
			TranslateSprite(THIS, -1, 0);
		}
	}
	
	if (THIS->x == -10) {
		SpriteManagerAdd(SPRITE_MONITOS, 160, 16);
	}
	
	
	
}

void Destroy_SPRITE_MONITOS() {
}