#pragma bank=2
#include "StateMision.h"
UINT8 bank_STATE_MISION = 2;

#include "..\res\src\initMapResources.h"
#include "..\res\src\misionTileMap.h"

#include "ZGBMain.h"
#include "Scroll.h"
#include "SpriteManager.h"

#include "Keys.h"
#include "Sound.h"


extern UINT8 n_sprite_types;
void Start_STATE_MISION() {
	UINT8 i;
	
	NR52_REG = 0x80; //Enables sound, you should always setup this first
    NR51_REG = 0xFF; //Enables all channels (left and right)
    NR50_REG = 0x77; //Max volume

	SPRITES_8x16;
	for(i = 0; i != n_sprite_types; ++ i) {
		SpriteManagerLoad(i);
	}
	SHOW_SPRITES;
	
	//cantidad de tiles
	InitScrollTiles(0, 127, initMapResources, 3);
	//los 0 son colisiones, no por ahora
	InitScroll(misionTileMapWidth, misionTileMapHeight, misionTileMap, 0, 0, 3);
	SHOW_BKG;
}

void Update_STATE_MISION() {
	if(KEY_TICKED(J_START)) {
		PlayFx(CHANNEL_4, 4, 0x0c, 0x41, 0x30, 0xc0);
		SetState(STATE_LEVEL);
	}
}