#pragma bank 2
#include "SpritePlayer.h"
#include "SpriteManager.h"
#include "Keys.h"
#include "SpriteMonoFeo.h"
#include "ZGBMain.h"
#include "Sound.h"

UINT8 bank_SPRITE_PLAYER = 2;

void Start_SPRITE_PLAYER() {
}

void Update_SPRITE_PLAYER() {
	
	UINT8 i;
	struct Sprite* spr;
	
	SPRITEMANAGER_ITERATE(i, spr) {
		if (spr->type == SPRITE_MONOFEO) {
			if (CheckCollision(THIS, spr)) {
				PlayFx(CHANNEL_2, 2, 0x8C, 0x92, 0xAB, 0x87);
				SetState(STATE_GAME);
			}
		}
	}
	
	
	
	if(KEY_PRESSED(J_UP)) {
		TranslateSprite(THIS, 0, -1 << delta_time);
	}
	
	if(KEY_PRESSED(J_DOWN)) {
		TranslateSprite(THIS, 0, 1 << delta_time);
	}
	
	if(KEY_PRESSED(J_LEFT)) {
		TranslateSprite(THIS, -1 << delta_time, 0);
	}
	
	if(KEY_PRESSED(J_RIGHT)) {
		TranslateSprite(THIS, 1 << delta_time, 0);
	}
	
}

void Destroy_SPRITE_PLAYER() {
}