#pragma bank 2
#include "StateMapaFeo.h"
UINT8 bank_STATE_MAPAFEO = 2;

#include "..\res\src\MapaFeoTiles.h"
#include "..\res\src\MapaFeo.h"

#include "ZGBMain.h"
#include "Scroll.h"
#include "SpriteManager.h"
#include "Sound.h"

extern UINT8* musiquita_mod_Data[];

extern UINT8 n_sprite_types;
void Start_STATE_MAPAFEO() {
	UINT8 i;
	
	UINT8 collision_tiles[] = {1, 2, 3, 4, 5, 6, 0};

	SPRITES_8x16;
	for(i = 0; i != n_sprite_types; ++ i) {
		SpriteManagerLoad(i);
	}
	SHOW_SPRITES;

	scroll_target = SpriteManagerAdd(SPRITE_PLAYER, 50, 50);
	SpriteManagerAdd(SPRITE_MONOFEO, 10, 10);

	InitScrollTiles(0, 8, MapaFeoTiles, 3);
	InitScroll(MapaFeoWidth, MapaFeoHeight, MapaFeo, collision_tiles, 0, 3);
	SHOW_BKG;
	
	NR52_REG = 0x80;
	NR51_REG = 0XFF;
	NR50_REG = 0X77;
	
	PlayMusic(musiquita_mod_Data, 3, 1);
}

void Update_STATE_MAPAFEO() {
}