#pragma bank 2
#include "StateLevel.h"
UINT8 bank_STATE_LEVEL = 2;

#include "..\res\src\LevelTiles.h"
#include "..\res\src\LevelMap.h"

#include "ZGBMain.h"
#include "Scroll.h"
#include "SpriteManager.h"

#include "Sound.h"

extern UINT8 n_sprite_types;

extern UINT8* musiquita_mod_Data[];

void Start_STATE_LEVEL() {
	UINT8 i;
	UINT8 collision_tiles[] = {1, 3, 4, 0};

	// ==================================================
	//eso carga sprites... dejemoslo asi nomas
	SPRITES_8x16;
	for(i = 0; i != n_sprite_types; ++ i) {
		SpriteManagerLoad(i);
	}
	SHOW_SPRITES;
	// ==================================================
	
	//los mismos sprites del otro escenario nomas

	SpriteManagerAdd(SPRITE_MONOFEO, 10, 10);
	scroll_target =SpriteManagerAdd(SPRITE_PLAYER, 50, 50);
	
	// ==================================================

	//cargar tiles
	InitScrollTiles(0, 5, LevelTiles, 3);
	
	//cargar mapa
	InitScroll(LevelMapWidth, LevelMapHeight, LevelMap, collision_tiles, 0, 3);
	SHOW_BKG;
	
	//pssst, asi se activa el audio de la gameboy
	NR52_REG = 0x80;	//activar sonido ...
	NR51_REG = 0xFF;	// ...con todos los canales...
	NR50_REG = 0x77;	// ... CON TODO EL POWER! 
	

	PlayMusic(musiquita_mod_Data, 3, 1);
	
}

void Update_STATE_LEVEL() {
	
}
