#pragma bank=2
#include "StateGame.h"
UINT8 bank_STATE_GAME = 2;

#include "..\res\src\initMapResources.h"
#include "..\res\src\initTileMap.h"

#include "ZGBMain.h"
#include "Scroll.h"
#include "SpriteManager.h"

#include "Keys.h"

#include "gbt_player.h"

extern UINT8* musiquita_mod_Data[];

extern UINT8 n_sprite_types;
void Start_STATE_GAME() {
	UINT8 i;
	
	NR52_REG = 0x80; //Enables sound, you should always setup this first
    NR51_REG = 0xFF; //Enables all channels (left and right)
    NR50_REG = 0x77; //Max volume

	SPRITES_8x16;
	for(i = 0; i != n_sprite_types; ++ i) {
		SpriteManagerLoad(i);
	}
	SHOW_SPRITES;

	scroll_target = SpriteManagerAdd(SPRITE_VENDEDOR, 40, 8);
	
	SpriteManagerAdd(SPRITE_MONITOS, 160, 16);
	
	//cantidad de tiles
	InitScrollTiles(0, 127, initMapResources, 3);
	//los 0 son colisiones, no por ahora
	InitScroll(initTileMapWidth, initTileMapHeight, initTileMap, 0, 0, 3);
	PlayMusic(musiquita_mod_Data, 3, 1);
	SHOW_BKG;
}

void Update_STATE_GAME() {
	if(KEY_TICKED(J_START)) {
		SetState(STATE_MISION);
	}
}