#pragma bank=2
#include "StateOver.h"
UINT8 bank_STATE_OVER = 2;

#include "..\res\src\initMapResources.h"
#include "..\res\src\overTileMap.h"

#include "ZGBMain.h"
#include "Scroll.h"
#include "SpriteManager.h"

#include "Keys.h"

#include "gbt_player.h"

extern UINT8* fin_mod_Data[];

extern UINT8 n_sprite_types;
void Start_STATE_OVER() {
	UINT8 i;
	
	NR52_REG = 0x80; //Enables sound, you should always setup this first
    NR51_REG = 0xFF; //Enables all channels (left and right)
    NR50_REG = 0x77; //Max volume

	SPRITES_8x16;
	for(i = 0; i != n_sprite_types; ++ i) {
		SpriteManagerLoad(i);
	}
	SHOW_SPRITES;
	
	//cantidad de tiles
	InitScrollTiles(0, 127, initMapResources, 3);
	//los 0 son colisiones, no por ahora
	InitScroll(overTileMapWidth, overTileMapHeight, overTileMap, 0, 0, 3);
	PlayMusic(fin_mod_Data, 3, 0);
	SHOW_BKG;
}

void Update_STATE_OVER() {
	if(KEY_TICKED(J_START)) {
		SetState(STATE_GAME);
	}
}